﻿Imports System.Data
Imports System.Configuration
Imports System.Data.SqlClient
Public Class Home
    Inherits System.Web.UI.Page


    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            If Not Me.Page.User.Identity.IsAuthenticated Then
                Response.Redirect("~/Login.aspx")
            End If
            If Me.Page.User.IsInRole("Administrator") Then
                pnlAssignRoles.Visible = True
                gvUsers.DataSource = GetData("SELECT UserId, Username, RoleId FROM Users")
                gvUsers.DataBind()
            End If
        End If
    End Sub

    Private Function GetData(query As String) As DataTable
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand(query)
                cmd.CommandType = CommandType.Text
                cmd.Connection = con
                Using sda As New SqlDataAdapter(cmd)
                    Dim dt As New DataTable()
                    sda.Fill(dt)
                    Return dt
                End Using
            End Using
        End Using
    End Function

    Protected Sub OnRowDataBound(sender As Object, e As GridViewRowEventArgs)
        If e.Row.RowType = DataControlRowType.DataRow Then
            Dim ddlRoles As DropDownList = TryCast(e.Row.FindControl("ddlRoles"), DropDownList)
            ddlRoles.DataSource = GetData("SELECT RoleId, RoleName FROM Roles")
            ddlRoles.DataTextField = "RoleName"
            ddlRoles.DataValueField = "RoleId"
            ddlRoles.DataBind()

            Dim assignedRole As String = TryCast(e.Row.DataItem, DataRowView)("RoleId").ToString()
            ddlRoles.Items.FindByValue(assignedRole).Selected = True
        End If
    End Sub

    Protected Sub UpdateRole(sender As Object, e As EventArgs)
        Dim row As GridViewRow = TryCast(TryCast(sender, Button).NamingContainer, GridViewRow)
        Dim userId As Integer = Integer.Parse(TryCast(sender, Button).CommandArgument)
        Dim roleId As Integer = Integer.Parse(TryCast(row.FindControl("ddlRoles"), DropDownList).SelectedItem.Value)
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As New SqlConnection(constr)
            Using cmd As New SqlCommand("UPDATE Users SET RoleId = @RoleId WHERE UserId = @UserId")
                cmd.Parameters.AddWithValue("@UserId", userId)
                cmd.Parameters.AddWithValue("@RoleId", roleId)
                cmd.CommandType = CommandType.Text
                cmd.Connection = con
                con.Open()
                cmd.ExecuteNonQuery()
                con.Close()
            End Using
        End Using
    End Sub

End Class

